Subroutine sub_CalcQC2
   !---------------------------------------------------------------------------------------
   !     Berechnet Guetemae gemae VDI-Richtlinie 3783 Blatt 16, Stand 01.06.2013.
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   INTEGER        :: ji ,jj ,jk ,npoints
   REAL           :: aFac1 ,aFac2 ,aFac3
   !
   do ji=lowb(1)+1,hghb(1)
   do jj=lowb(2)+1,hghb(2)
      !
      do jk=lowb(3)+1,hghb(3)
         !
         if ( zlvl(jk) > 100. ) EXIT
         !
         if (.not. lstetig(ji,jj,jk) ) then
            gfxyz_c(ji,jj,jk) = -999.
            gdxyz_c(ji,jj,jk) = -999.
         else
            !
            gfxyz_c(ji,jj,jk) = gfxyz_c(ji,jj,jk) / REAL(nKorr)
            gfxyz_c(ji,jj,jk) = MIN( gfxyz_c(ji,jj,jk) , 1./(gfxyz_c(ji,jj,jk)+1.e-9) )
            aFac1 = Sum1d3d(ji,jj,jk) - Sum1d(jk)*Sum3d(ji,jj,jk)/REAL(2*nKorr)
            aFac2 = Sum1d1d(jk)       - Sum1d(jk)**2.            /REAL(2*nKorr)
            aFac3 = Sum3d3d(ji,jj,jk) - Sum3d(ji,jj,jk)**2.      /REAL(2*nKorr)
            gdxyz_c(ji,jj,jk) = aFac1*aFac1 / (aFac2*aFac3)
         end if
      end do
      !
      gdxy_c(ji,jj) = 0.
      gfxy_c(ji,jj) = 0.
      !
      npoints = 0
      do jk=lowb(3)+1,hghb(3)
         !
         if ( zlvl(jk) > 100. ) EXIT
         !
         if (.not. lstetig(ji,jj,jk) ) then
            gfxy_c(ji,jj) = -999.
            gdxy_c(ji,jj) = -999.
            EXIT
         ELSE
            gfxy_c(ji,jj) = gfxy_c(ji,jj) + gfxyz_c(ji,jj,jk)
            gdxy_c(ji,jj) = gdxy_c(ji,jj) + gdxyz_c(ji,jj,jk)
            npoints = npoints + 1
         ENDIF
      ENDDO
      if ( gdxy_c(ji,jj) >= 0. ) gdxy_c(ji,jj) = gdxy_c(ji,jj) / REAL(npoints)
      if ( gfxy_c(ji,jj) >= 0. ) gfxy_c(ji,jj) = gfxy_c(ji,jj) / REAL(npoints)
   end do
   end do
   !
END Subroutine
