Subroutine sub_ReadDir
   !---------------------------------------------------------------------------------------
   !     Einlesen der Namen aller Dateien des Bibliotheksverzeichnisses
   !     Es wird die Routine SYSTEM verwendet, die kein FORTRAN 95 Standard ist.
   !     Alternativ kann ab FORTRAN 2008 die Routine
   !     execute_command_line(command [, wait, exitstat, cmdstat, cmdmsg])
   !     verwendet werden.
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   REAL           :: add
   INTEGER        :: istat ,iGrid ,iDD ,iAK ,nwFiles ,jf ,iDD2 ,iDDc ,nDDlocal ,nDDlocal6(1:nAKS)
   CHARACTER*13   :: dwFile
   CHARACTER*280  :: cl
   !---------------------------------------------------------------------------------------
   !
   cl = 'dir '//TRIM(cLib)//'\w*.dmna /B /O > dirlist.txt'
   call system(TRIM(cl))
   open (1,FILE='dirlist.txt',IOSTAT=istat)
   if ( istat /= 0 ) GOTO 999
   !
   nwFiles  = 0
   nGrids   = 1
   n2Basis  = 0
   nDD      = 0
   do WHILE ( istat == 0 )
      read (1,'(A)',IOSTAT=istat) dwFile
      if ( istat /= 0 ) cycle
      nwFiles = nwFiles + 1
      !
      read (dwFile(7:7),'(I1)',IOSTAT=istat) iGrid
      if ( istat /= 0 ) GOTO 998
      nGrids = MAX(nGrids,iGrid)
      !
      if ( dwFile(4:5) == 'sn' .or. dwFile(4:5) == 'we' ) then
         n2Basis = 1
         nDD = 2
      else
         if ( n2Basis == 1 ) GOTO 997
         read (dwFile(4:5),'(I2)',IOSTAT=istat) iDD
         if ( istat /= 0 ) GOTO 996
         if ( iDD <= 0 .or. iDD > 36 ) GOTO 996
         nDD = MAX(nDD,iDD)
      end if
      !
      read (dwFile(2:2),'(I1)',IOSTAT=istat) iAK
      if ( istat /= 0 ) GOTO 995
      if ( iAK < 1 .or. iAK > nAKS ) GOTO 995
   end do
   !
   ALLOCATE ( cwFiles(1:nAKS,1:nDD,1:nGrids) ,ddFiles(1:nAKS,1:nDD,1:nGrids) )
   !
   cwFiles = ' '
   ddFiles  = -999.
   Ref1dDD0 = -999.
   REWIND 1
   do jf=1,nwFiles
      read (1,'(A)') dwFile
      read (dwFile(7:7),'(I1)',IOSTAT=istat) iGrid
      if ( iGrid == 0 ) iGrid = 1
      read (dwFile(2:2),'(I1)',IOSTAT=istat) iAK
      if ( n2Basis == 1 .and. dwFile(4:5) == 'sn' ) then
         iDD = 1
         add = 180.
      elseif ( n2Basis == 1 .and. dwFile(4:5) == 'we' ) then
         iDD = 2
         add = 270.
      else
         read (dwFile(4:5),'(I2)',IOSTAT=istat) iDD
         add = 10.*float(iDD)
      end if
      cwFiles(iAK,iDD,iGrid) = dwFile
      ddFiles(iAK,iDD,iGrid) = add
      !
      if ( cf1d(iAK) == dwFile(1:5) ) Ref1dDD0(iAK) = add
   end do
   close (1)
   call system('del dirlist.txt')
   if ( MINVAL(Ref1dDD0) < 0. ) GOTO 994
   !
   do iGrid=1,nGrids
   do iAK=1,nAKS
      do iDD=1,nDD-1
         if ( cwFiles(iAK,iDD,iGrid) == ' ' ) then
            iDDc = -9
            do iDD2=iDD,nDD
               if ( cwFiles(iAK,iDD2,iGrid) /= ' ' ) then
                  iDDc = iDD2
                  EXIT
               end if
            end do
            if ( iDDc > 0 ) then
               cwFiles(iAK,iDD ,iGrid) = cwFiles(iAK,iDDc,iGrid)
               ddFiles(iAK,iDD ,iGrid) = ddFiles(iAK,iDDc,iGrid)
               cwFiles(iAK,iDDc,iGrid) = ' '
               ddFiles(iAK,iDDc,iGrid) = -999.
            end if
         end if
      end do
   end do
   end do
   !
   nDDlocal  = 0
   nDDlocal6 = 0
   do iGrid=1,nGrids
   do iAK=1,nAKS
   do iDD=1,nDD
      if ( cwFiles(iAK,iDD,iGrid) /= ' ' ) nDDlocal6(iAK) = MAX(nDDlocal6(iAK),iDD)
   end do
   end do
   end do
   do iAK=1,nAKS
      nDDlocal = MAX(nDDlocal,nDDlocal6(iAK))
   end do
   !
   do iAK=2,nAKS
      if ( nDDlocal6(iAK) /= nDDlocal6(iAK-1) ) GOTO 993
   end do
   !
   if ( nDDlocal == 2 .and. cwFiles(1,1,1)(4:5) == '18' .and. cwFiles(1,2,1)(4:5) == '27' ) n2Basis = 1
   IF ( n2Basis == 1 ) then
      write (99,*)
      write (99,'(3A)') 'Das Verzeichnis "',TRIM(clib),'" enthaelt zwei Basis-Windfelder je AK-Klasse.'
   endif
   !
   write (99,*)
   write (99,'(3A,I2,A)') 'Im Verzeichnis "',TRIM(clib),'" wurden Dateien von ',nGrids,' (genesteten) Gitter(n)'
   write (99,'(A,I3,A)')  'und von (bis zu) ',nDDlocal,' Windrichtungssektoren gefunden:'
   do iGrid=1,nGrids
      write (99,*)
      write (99,'(A,I2,A)') 'Gitter ',iGrid,':'
      write (99,'(A)') '----------'
      write (99,'(A)')  'AK1             AK2             AK3-1           AK3-2           AK4             AK5'
      do iDD=1,nDDlocal
         write (99,'(6(A8,1x,A,I3,A,1x))') ( TRIM(cwFiles(iAK,iDD,iGrid)(1:8)),'(',NINT(ddFiles(iAK,iDD,iGrid)),')' ,iAK=1,nAKS)
      end do
   end do
   write (99,*)
   write (99,'(A)') '==============================================================================================='
   write (99,'(A)') 'WICHTIGER HINWEIS:'
   write (99,'(A)') '==============================================================================================='
   write (99,'(A)') 'Es wird ungeprueft davon ausgegangen, dass alle Bibliotheksdateien (Windfelddateien)'
   write (99,'(A)') 'in einem Speicherformat der Form'
   write (99,'(A)') '   form    "Zp%N.Nf" "Vx%N.Nf" "Vy%N.Nf" "Vs%N.Nf" '
   write (99,'(A)') 'und der Speicherreihenfolge'
   write (99,'(A)') '   sequ    "i,j,k"'
   write (99,'(A)') 'vorliegen!'
   write (99,'(A)') 'Bei abweichenden Formaten erfolgt moeglicherweise kein Programmabbruch.'
   write (99,'(A)') 'Der berechnete Anemometerstandort ist dann aber fehlerhaft!'
   write (99,'(A)') '==============================================================================================='
   write (99,*)
   !
   RETURN
   !
999 CONTINUE
   write (99,'(A)') 'Fehler beim Einlesen der Datei dirlist.txt'
   STOP 'Fehler beim Einlesen der Datei dirlist.txt'
998 CONTINUE
   write (99,'(A)') 'Fehler: Bibliotheksverzeichnis enthaelt ungueltige Dateinamen (Gitterindex)'
   write (99,'(2A)') '        Dateiname: ',TRIM(dwFile)
   STOP  'Fehler: Bibliotheksverzeichnis enthaelt ungueltige Dateinamen (Gitterindex)'
997 CONTINUE
   write (99,'(A)') 'Fehler: Bibliotheksverzeichnis enthaelt neben Basisfeldern (sn/we) weitere Anstroemrichtungen'
   write (99,'(2A)') '        Dateiname: ',TRIM(dwFile)
   STOP 'Fehler: Bibliotheksverzeichnis enthaelt neben Basisfeldern (sn/we) weitere Anstroemrichtungen'
996 CONTINUE
   write (99,'(A)') 'Fehler: Bibliotheksverzeichnis enthaelt ungueltige Dateinamen (Windsektor)'
   write (99,'(2A)') '        Dateiname: ',TRIM(dwFile)
   STOP  'Fehler: Bibliotheksverzeichnis enthaelt ungueltige Dateinamen (Windsektor)'
995 CONTINUE
   write (99,'(A)') 'Fehler: Bibliotheksverzeichnis enthaelt ungueltige Dateinamen (Stab.klasse)'
   write (99,'(2A)') '        Dateiname: ',TRIM(dwFile)
   STOP  'Fehler: Bibliotheksverzeichnis enthaelt ungueltige Dateinamen (Stab.klasse)'
994 CONTINUE
   write (99,*) 'Fehler: Bibliothek enthaelt kein Feld mit der Kennung des 1d-Referenzprofils'
   STOP         'Fehler: Bibliothek enthaelt kein Feld mit der Kennung des 1d-Referenzprofils'
993 CONTINUE
   write (99,'(3A)') 'Fehler: Das Verzeichnis "',TRIM(clib),'" enthaelt unterschiedliche Anzahl Windfelder je AK-Klasse.'
   STOP 'Bibliotheksverzeichnis enthaelt unterschiedliche Anzahl Windfelder je AK-Klasse.'
   !
END Subroutine
