Subroutine sub_ReadHeader(nCall,nMode,dFile)
   !---------------------------------------------------------------------------------------
   !     Liest den Header einer dmna-Datei aus der Windfeldbibliothek.
   !     Die Datei wird als UNIT 1 geoffnet. Handelt es sich nur um eine
   !     Headerdatei, so wird sie wieder geschlossen und die zugehoerige Binrdatei geffnet.
   !     Ist es eine komplette Windfelddatei, so bleibt sie zum Weiterlesen geffnet.
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   INTEGER        :: istat ,istatb ,ic ,nCall ,nMode ,idims ,ilowb(3) ,ihghb(3) ,iLine
   REAL           :: arefx ,arefy ,axmin ,aymin ,adelta
   CHARACTER*90   :: dLineVal
   CHARACTER*100  :: dLine
   CHARACTER*13   :: dFile
   CHARACTER*269  :: dFileA ,dFileB
   !---------------------------------------------------------------------------------------
   dFileA = TRIM(clib)//'\'//TRIM(dFile)
   ilowb  = +999
   ihghb  = -999
   arefx  = 0.
   arefy  = 0.
   axmin  = 0.
   aymin  = 0.
   adelta = 0.
   !
   if ( nCall == 1 ) then
      lowb  = +999
      hghb  = -999
      refx  = 0.
      refy  = 0.
      xmin  = 0.
      ymin  = 0.
      delta = 0.
   end if
   !
   nMode = 0
   !
   open (1,FILE=TRIM(dfileA),IOSTAT=istat)
   if ( istat /= 0 ) then
      write (99,'(2A)') 'Fehler beim Oeffnen der Bibliotheksdatei ',TRIM(dFileA)
      STOP 'Fehler beim Oeffnen einer Bibliotheksdatei'
   end if
   !
   iLine = 0
   do WHILE ( istat == 0 )
      iLine = iLine + 1
      dLine = ' '
      read (1,'(A)',IOSTAT=istat) dLine
      if ( istat /= 0 ) then
         write (99,'(2A)')   'Fehler beim Lesen Dateiheader von Bibliotheksdatei ',TRIM(dFileA)
         write (99,'(A,I3)') '       Zeile ',iline
         STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
      endif
      !
      if ( dLine(1:1) == '*' ) then
         istat = 1
         !
         if ( nMode == 1 ) then
            CLOSE (1)
            !
            ic = INDEX(dFileA,'dmna',BACK=.TRUE.)
            if ( ic > 0 ) then
               dFileB = dFileA
               dFileB(ic:ic+3) = 'dmnb'
            else
               write (99,'(A)') 'interner Fehler: Dateiendung dmna nicht in Dateinamen gefunden'
               STOP 'interner Fehler (Index dmna)'
            end if
            !
            open (1,FILE=TRIM(dFileB),FORM='unformatted',IOSTAT=istatb)
            if ( istatb /= 0 ) then
               write (99,'(2A)') 'Fehler beim Oeffnen der Bibliotheksdatei ',TRIM(dFileB)
               STOP 'Fehler beim Oeffnen einer Bibliotheksdatei'
            end if
            !
            CYCLE
         end if
      end if
      !
      Call Char2Low(100,1,dLine)
      !
      dLine = TRIM(ADJUSTL(dLine))
      !
      if ( dLine(1:4) == 'dims' ) then
         dLineVal = TRIM(ADJUSTL(dLine(5:95)))
         idims = 0
         read (dLineVal(1:1),*,IOSTAT=istat) idims
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter DIMS von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
         if ( idims /= 3 ) then
            write (99,'(A)') 'Fehler: Parameter DIMS muss 3 sein'
            write (99,'(2A,I)')  '        Wert von Parameter DIMS in Datei "',TRIM(dFileA),'": ',idims
            STOP 'Fehler: Parameter DIMS muss 3 sein'
         end if
      end if
      !
      if ( dLine(1:4) == 'lowb' ) then
         dLineVal = TRIM(ADJUSTL(dLine(5:95)))
         read (dLineVal,*,IOSTAT=istat) ilowb
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter LOWB von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:4) == 'hghb' ) then
         dLineVal = TRIM(ADJUSTL(dLine(5:95)))
         read (dLineVal,*,IOSTAT=istat) ihghb
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter HGHB von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:4) == 'refx' .OR. dLine(1:5) == 'gakrx' ) then
         dLineVal = TRIM(ADJUSTL(dLine(6:95)))
         read (dLineVal,*,IOSTAT=istat) arefx
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter REFX/GAKRX von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:4) == 'refy' .OR. dLine(1:5) == 'gakry' ) then
         dLineVal = TRIM(ADJUSTL(dLine(6:95)))
         read (dLineVal,*,IOSTAT=istat) arefy
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter REFY/GAKRY von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:4) == 'xmin' ) then
         dLineVal = TRIM(ADJUSTL(dLine(5:95)))
         read (dLineVal,*,IOSTAT=istat) axmin
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter XMIN von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:4) == 'ymin' ) then
         dLineVal = TRIM(ADJUSTL(dLine(5:95)))
         read (dLineVal,*,IOSTAT=istat) aymin
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter YMIN von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:5) == 'delta' ) then
         dLineVal = TRIM(ADJUSTL(dLine(6:95)))
         read (dLineVal,*,IOSTAT=istat) adelta
         if ( istat /= 0 ) then
            write (99,'(3A)') 'Fehler beim Lesen von Parameter DELTA von Bibliotheksdatei "',TRIM(dFileA),'"'
            STOP 'Fehler beim Lesen Dateiheader von Bibliotheksdatei'
         endif
      end if
      !
      if ( dLine(1:4) == 'mode' ) then
         dLineVal = TRIM(ADJUSTL(dLine(5:95)))
         if ( INDEX(dLineVal,'binary') /= 0 ) nMode = 1
      end if
   enddo
   !
   if ( nCall == 1) then
      lowb = ilowb
      hghb = ihghb
      if ( lowb(1) > hghb(1) .or. lowb(2) > hghb(2) .or. lowb(3) > hghb(3) ) then
         write (99,'(A)') 'Fehler: unzulaessige Felddimensionen'
         write (99,'(A,3I)') '        lowb: ',lowb
         write (99,'(A,3I)') '        hghb: ',hghb
         STOP 'Fehler: unzulaessige Felddimensionen'
      end if
      refx = arefx
      refy = arefy
      xmin = axmin
      ymin = aymin
      delta = adelta
      close (1)
   !
   else
      if ( ilowb(1) /= lowb(1) .or. ilowb(2) /= lowb(2) .or. ilowb(3) /= lowb(3) ) then
         write (99,'(3A)')   'Fehler: Parameter lowb von Bibliotheksdatei "',TRIM(dFileA),'"'
         write (99,'(A)')    '        stimmt nicht mit anderen Dateien ueberein:'
         write (99,'(A,3I)') '        lowb aktuelle Datei: ',ilowb
         write (99,'(A,3I)') '        lowb andere Dateien: ',lowb
         STOP 'Fehler: unterschiedliche Felddimensionen'
      end if
      if ( ihghb(1) /= hghb(1) .or. ihghb(2) /= hghb(2) .or. ihghb(3) /= hghb(3) ) then
         write (99,'(3A)')   'Fehler: Parameter hghb von Bibliotheksdatei "',TRIM(dFileA),'"'
         write (99,'(A)')    '        stimmt nicht mit anderen Dateien ueberein:'
         write (99,'(A,3I)') '        hghb aktuelle Datei: ',ihghb
         write (99,'(A,3I)') '        hghb andere Dateien: ',hghb
         STOP 'Fehler: unterschiedliche Felddimensionen'
      end if
      if ( ABS(arefx-refx) > 1.e-6 .OR. ABS(arefy-refy) > 1.e-6 ) then
         write (99,'(3A)')   'Fehler: Parameter refx/y von Bibliotheksdatei "',TRIM(dFileA),'"'
         write (99,'(A)')    '        stimmt nicht mit anderen Dateien ueberein:'
         write (99,'(A,2(F9.1,1x))') '        refx/y aktuelle Datei: ',arefx,arefy
         write (99,'(A,2(F9.1,1x))') '        refx/y andere Dateien: ',refx,refy
         STOP 'Fehler: unterschiedliche Referenzkoordinaten'
      end if
      if ( ABS(axmin-xmin) > 1.e-6 .OR. ABS(aymin-ymin) > 1.e-6 ) then
         write (99,'(3A)')   'Fehler: Parameter x/ymin von Bibliotheksdatei "',TRIM(dFileA),'"'
         write (99,'(A)')    '        stimmt nicht mit anderen Dateien ueberein:'
         write (99,'(A,2(F9.1,1x))') '        x/ymin aktuelle Datei: ',axmin,aymin
         write (99,'(A,2(F9.1,1x))') '        x/ymin andere Dateien: ',xmin,ymin
         STOP 'Fehler: unterschiedliche Referenzkoordinaten'
      end if
      if ( ABS(adelta-delta) > 1.e-6 ) then
         write (99,'(3A)')   'Fehler: Parameter delta von Bibliotheksdatei "',TRIM(dFileA),'"'
         write (99,'(A)')    '        stimmt nicht mit anderen Dateien ueberein:'
         write (99,'(A,F6.1)') '        delta aktuelle Datei: ',adelta
         write (99,'(A,F6.1)') '        delta andere Dateien: ',delta
         STOP 'Fehler: unterschiedliche Referenzkoordinaten'
      end if
   end if
   !
END Subroutine
