Subroutine sub_ReadWind(nCall,nMode,nCallsH)
   !---------------------------------------------------------------------------------------
   !     Liest das Windfeld einer dmna/b-Datei aus der Windfeldbibliothek.
   !     Die Datei ist bereits als UNIT 1 geoffnet.
   !     Aus den Komponenten wird die aktuelle Windrichtung und Windgeschwindigkeit berechnet.
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   INTEGER           :: istat ,nCall ,nMode ,ji ,jj ,jk ,nx ,ny ,nCallsH
   REAL              :: rdum ,au ,av ,avv ,add ,api
   REAL ,ALLOCATABLE :: zhlp(:)
   !---------------------------------------------------------------------------------------
   api = 4.*ATAN(1.)
   nx = hghb(1)-lowb(1)+1
   ny = hghb(2)-lowb(2)+1
   !
   if ( nMode == 1 ) then
      do ji=lowb(1),hghb(1)
      do jj=lowb(2),hghb(2)
      do jk=lowb(3),hghb(3)
         read (1,iostat=istat) zp(ji,jj,jk) ,u(ji,jj,jk) ,v(ji,jj,jk) ,w(ji,jj,jk)
         if ( istat /= 0 ) then
            write (99,'(A)') 'Fehler beim Lesen Windfeld aus Bibliotheksdatei ("binary")'
            STOP 'Fehler beim Lesen Windfeld aus Bibliotheksdatei ("binary")'
         endif
      end do
      end do
      end do
   else
      do ji=lowb(1),hghb(1)
      do jj=lowb(2),hghb(2)
         do jk=lowb(3),hghb(3)
            read (1,*,iostat=istat) zp(ji,jj,jk) ,u(ji,jj,jk) ,v(ji,jj,jk) ,w(ji,jj,jk)
            if ( istat /= 0 ) then
               write (99,'(A)') 'Fehler beim Lesen Windfeld aus Bibliotheksdatei ("text")'
               STOP 'Fehler beim Lesen Windfeld aus Bibliotheksdatei ("text")'
            endif
         end do
         read (1,*)
      end do
      end do
   end if
   !
   do jk=lowb(3)+1,hghb(3)
      zlvl(jk) = 0.5*(zp(1,1,jk-1)+zp(1,1,jk)) - zp(1,1,0)
   enddo
   !
   do ji=lowb(1)+1,hghb(1)
   do jj=lowb(2)+1,hghb(2)
   do jk=lowb(3)+1,hghb(3)
      au = 0.5 * ( u(ji-1,jj,jk) + u(ji,jj,jk) )
      av = 0.5 * ( v(ji,jj-1,jk) + v(ji,jj,jk) )
      avv = SQRT( au*au + av*av )
      IF ( ABS(avv) >= ffMin ) THEN
         add = ATAN2(au,av) * 180./api + 180.
         IF ( add >= 360. ) add = add - 360.
      ELSE
         add = -999.
      END IF
      add = NINT(10.*add)/10.
      if ( nCall == 1 ) then
         ddm1(ji,jj,jk) = add
         !
         if ( n2Basis == 1 ) then
            ddm1(ji,jj,jk) = ddm1(ji,jj,jk) + 180.
            if ( ddm1(ji,jj,jk) >= 360. ) ddm1(ji,jj,jk) = ddm1(ji,jj,jk) - 360.
         end if
      else
         dd(ji,jj,jk) = add
         ff(ji,jj,jk) = avv + ff(ji,jj,jk)
         ffact(ji,jj,jk) = avv
      end if
   end do
   end do
   end do
   !
   close (1)
   !
END Subroutine
