Subroutine sub_CalcAnemo(jgrid)
   !---------------------------------------------------------------------------------------
   !     Berechnet den optimalen Anemometerstandort pro Modellebene.
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   INTEGER,ALLOCATABLE :: nClass(:) ,nID(:,:) ,nIDhlp(:,:) ,nClsPts(:) ,indx(:) ,indy(:)
   INTEGER             :: nGoodPoints ,ji ,jj ,jk ,jgrid,jn1,jn2,nRang
   INTEGER             :: nx ,ny ,jp ,iRand ,i_unten,i_oben,j_unten,j_oben,k_unten, k_oben
   INTEGER             :: jCMax,nClsMax,nPtsMax,jc,np,jn
   INTEGER             :: iBest0 ,iBestA ,iBestB ,iBestC ,jBest0 ,jBestA ,jBestB ,jBestC
   REAL                :: xBest ,yBest ,GBestC
   REAL                :: GG_c_1st ,GG_c ,g_c ,xx_1st ,yy_1st ,gd_1st ,gf_1st ,gg_1st
   INTEGER             :: ji_1st ,jj_1st ,ID_c_1st ,ipt
   INTEGER             :: ijloc(2)
   !
   INTEGER :: z1d
   z1d(ji,jj) = 1 + (ji-i_unten) + (jj-j_unten)*nx
   !
   iRand = 0
   if ( jgrid == 1 ) iRand = nRandPkte
   !
   i_unten = lowb(1) + 1 + iRand
   i_oben  = hghb(1)     - iRand
   j_unten = lowb(2) + 1 + iRand
   j_oben  = hghb(2)     - iRand
   k_unten = lowb(3) + 1
   k_oben  = hghb(3)
   !
   nx = i_oben - i_unten + 1
   ny = j_oben - j_unten + 1
   if (nx < 1 .or. ny < 1 ) then
      write (99,*) 'Modellgebiet fr eine Auswertung zu klein.'
      STOP 'Modellgebiet fr eine Auswertung zu klein.'
   end if
   if ( nx*ny > nxym ) then
      write (99,*) 'Limit fuer Anzahl Gitterpunkte ueberschritten. Auswertung nicht mglich.'
      write (99,*) 'Bitte Modellgebiet auf weniger als 400 Punkte je Richtung verkleinern.'
      STOP 'Gitterpunktlimitierung ueberschritten'
   end if
   !
   ALLOCATE ( nID     (i_unten:i_oben,j_unten:j_oben) &
             ,nIDhlp  (i_unten:i_oben,j_unten:j_oben) &
             ,nClass  (1:nx*ny)                       &
             ,nClsPts (1:nx*ny)                       &
             ,indx    (1:nx*ny)                       &
             ,indy    (1:nx*ny)                      )
   !
   do jj=j_unten,j_oben
   do ji=i_unten,i_oben
      jn1 = z1d(ji,jj)
      indx(jn1) = ji
      indy(jn1) = jj
   end do
   end do
   !
   ff      = ff      / (nAKS*nDD)
   dddelta = dddelta / (nAKS*nDD)
   !
   do jk=k_unten,k_oben
      !
      if ( zlvl(jk) > 100. ) EXIT
      !
      write (99,*)
      write (99,'(A,I3,A,F6.1,A)') '******************    Modelllevel: ',jk,' - Levelhoehe ueber Grund: ' &
                                  ,zlvl(jk),' m                    ******************'
      write (99,*)
      if ( lLong ) then
         write (98,*)
         write (98,'(A,I3,A,F6.1,A)') '******************    Modelllevel: ',jk,' - Levelhoehe ueber Grund: ' &
                                     ,zlvl(jk),' m                    ******************'
         write (98,*)
         write (98,'(A)') 'Gebiet-ID       G     i-Index j-Index       x(m)      y(m)        gd         gf         g'
      endif
      !
      nID    = 0
      nIDhlp = 0
      !
      nGoodPoints = 0
      do ji=i_unten,i_oben
      do jj=j_unten,j_oben
         if ( lStetig(ji,jj,jk) ) then
            nGoodPoints = nGoodPoints + 1
         else
            dddelta(ji,jj,jk) = 9.e9
            ff     (ji,jj,jk) = 9.e9
         endif
      end do
      end do
      !
      if (nGoodPoints == 0) then
         write (99,'(A)') '.................. Level enthaelt keinen Gitterpunkt mit stetiger Winddrehung!'
         write (99,'(A)') '.................. Ersatz-Anemometerposition kann fuer dieses Level nicht bestimmt werden!'
         if ( lLong ) then
            write (98,'(A)') '.................. Level enthaelt keinen Gitterpunkt mit stetiger Winddrehung!'
            write (98,'(A)') '.................. Ersatz-Anemometerposition kann fuer dieses Level nicht bestimmt werden!'
         endif
         CYCLE
      end if
      !
      nClass(1) = 1
      do jn1=2,nx*ny
         nClass(jn1) = jn1
         if ( .not. lstetig(indx(jn1),indy(jn1),jk) ) CYCLE
         !
         do jn2=1,jn1-1
            nClass(jn2) = nClass(nClass(jn2))
            if ( .not. lstetig(indx(jn2),indy(jn2),jk) ) CYCLE
            if ( ( indx(jn1) == indx(jn2) .AND.  ABS(indy(jn2)-indy(jn1)) == 1 ) .OR. ( indy(jn1) == indy(jn2) .AND. ABS(indx(jn2)-indx(jn1)) == 1 ) ) &
               nClass(nClass(nClass(jn2))) = jn1
         end do
      enddo
      do jn1=1,nx*ny
         nClass(jn1) = nClass(nClass(jn1))
      end do
      !
      do jn1=1,nx*ny
         if (.not. lstetig(indx(jn1),indy(jn1),jk) ) nClass(jn1) = -999
         nID(indx(jn1),indy(jn1)) = nClass(jn1)
      end do
      !
      nRang = 0
      nClsPts = 0
      jCMax = MAXVAL(nClass)
      DO WHILE ( jCMax > 0 )
         !
         nClsMax = 0
         nPtsMax = 0
         do jc=1,jCMax
            np=0
            do jn=1,nx*ny
               if ( nClass(jn) == jc ) np = np + 1
            end do
            if ( np > nPtsMax ) then
               nPtsMax = np
               nClsMax = jc
            end if
         enddo
         !
         nRang = nRang + 1
         nClsPts(nRang) = nPtsMax
         do jj=j_unten,j_oben
         do ji=i_unten,i_oben
            if ( nID(ji,jj) == nClsMax ) nIDhlp(ji,jj) = nRang
         end do
         end do
         do jn1=1,nx*ny
            if ( nClass(jn1) == nClsMax ) nClass(jn1) = 0
         end do
         !
         jCMax = MAXVAL(nClass)
      END DO
      !
      do jj=j_unten,j_oben
      do ji=i_unten,i_oben
         if ( nID(ji,jj) >= 0 ) nID(ji,jj) = nIDhlp(ji,jj)
      end do
      end do
      !
      write (99,'(A)') '...............................................................................................'
      write (99,'(A)') 'Liste aller zusammenhaengenden Gebiete mit stetiger Winddrehung und deren integrale Guetemasse:'
      write (99,'(A)') '(Absteigende Sortierung nach Groesse)'
      GG_c_1st = -999.
      ID_c_1st = -999
      do jn1=1,nx*ny
         if ( jn1 > MAXVAL(nID) ) EXIT
         GG_c = 0.
         ipt = 0
         do jj=j_unten,j_oben
         do ji=i_unten,i_oben
            if ( nID(ji,jj) /= jn1 ) CYCLE
            g_c = gdxyz_c(ji,jj,jk)*gfxyz_c(ji,jj,jk)
            GG_c = GG_c + g_c
            ipt = ipt + 1
         end do
         end do
         write (99,'(A,I4.4,A,F8.1,A,I5.5)') ' Gebiet: ',jn1,' G = ',GG_c,' Anzahl Punkte: ',ipt
         !
         if ( lLong ) then
           do jj=j_unten,j_oben
           do ji=i_unten,i_oben
              if ( nID(ji,jj) /= jn1 ) CYCLE
              write (98,'(I9,2x,F9.2,1x,2(1x,I7)1x,2(1x,F9.0),1x,3(1x,F10.2))') &
                    nID(ji,jj) ,GG_c ,ji ,jj ,refx + xmin + (ji-0.5)*delta ,refy + ymin + (jj-0.5)*delta ,gdxyz_c(ji,jj,jk) ,gfxyz_c(ji,jj,jk) ,g_c
           end do
           end do
         endif
         !
         if ( GG_c > GG_c_1st ) then
            GG_c_1st = GG_c
            ID_c_1st = jn1
         end if
      end do
      !
      jn1 = ID_c_1st
      ji_1st = -999
      jj_1st = -999
      xx_1st = -999.
      yy_1st = -999.
      gd_1st = -999.
      gf_1st = -999.
      gg_1st = -999.
      do jj=j_unten,j_oben
      do ji=i_unten,i_oben
         if ( nID(ji,jj) /= jn1 ) CYCLE
         g_c = gdxyz_c(ji,jj,jk)*gfxyz_c(ji,jj,jk)
         if ( g_c <= gg_1st ) CYCLE
         !
         gg_1st = g_c
         gd_1st = gdxyz_c(ji,jj,jk)
         gf_1st = gfxyz_c(ji,jj,jk)
         xx_1st = refx + xmin + (ji-0.5)*delta
         yy_1st = refy + ymin + (jj-0.5)*delta
         ji_1st = ji
         jj_1st = jj
      end do
      end do
      write (99,'(A)') '...............................................................................................'
      write (99,'(A,I7)'   ) 'Empfohlener Ersatzanemometerort: Gebiets-ID = ',ID_c_1st
      write (99,'(A,F9.1)' ) '                                   Gesamt-G = ',GG_c_1st
      write (99,'(A)'      ) '                                   EAP-Punkt:'
      write (99,'(A,I7)'   ) '                                    i-Index = ',ji_1st
      write (99,'(A,I7)'   ) '                                    j-Index = ',jj_1st
      write (99,'(A,F9.0)' ) '                                      x (m) = ',xx_1st
      write (99,'(A,F9.0)' ) '                                      y (m) = ',yy_1st
      write (99,'(A,F10.2)') '                                         gd = ',gd_1st
      write (99,'(A,F10.2)') '                                         gf = ',gf_1st
      write (99,'(A,F10.2)') '                                          g = ',gg_1st
      write (99,'(A)') '...............................................................................................'
      !
   enddo
   !
END Subroutine
