Subroutine sub_CalcQC(jak,jdd,jgrid)
   !---------------------------------------------------------------------------------------
   !     Berechnet Guetemae gemae VDI-Richtlinie 3783 Blatt 16, Stand 01.06.2013.
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   REAL ,ALLOCATABLE :: u1d(:) ,v1d(:)
   REAL              :: api ,abog ,aff ,add ,adddiff ,afac ,aff1d ,aff3d ,au ,av &
                       ,u_unten, u_oben ,v_unten ,v_oben ,z_unten ,z_oben
   INTEGER           :: jak ,jdd ,jgrid
   INTEGER           :: ji ,jj ,jk ,jkk
   REAL              :: adelta ,adeltaHW
   !
   api  = 4.*ATAN(1.)
   abog = api/180.
   !
   nKorr = nKorr + 1
   !
   if (.not. ALLOCATED(u1d)) then
      ALLOCATE ( u1d(lowb(3)+1:hghb(3)) ,v1d(lowb(3)+1:hghb(3)) )
      u1d = -999.
      v1d = -999.
   end if
   adddiff = ddFiles(jak,jdd,jgrid) - Ref1dDD0(jak)
   do jk=lowb(3)+1,hghb(3)
      !
      if ( zlvl(jk) > 100. ) EXIT
      !
      do jkk=1,n1d-1
         if ( Ref1dzz(jkk) <= zlvl(jk) .and. Ref1dzz(jkk+1) >= zlvl(jk) ) then
            add = Ref1ddd(jkk,jak) + adddiff
            if ( add <    0. ) add = add + 360.
            if ( add >= 360. ) add = add - 360.
            aff = Ref1dff(jkk,jak)
            u_unten = aff * SIN(abog*add)
            v_unten = aff * COS(abog*add)
            z_unten = Ref1dzz(jkk)
            add = Ref1ddd(jkk+1,jak) + adddiff
            if ( add <    0. ) add = add + 360.
            if ( add >= 360. ) add = add - 360.
            aff = Ref1dff(jkk+1,jak)
            u_oben = aff * SIN(abog*add)
            v_oben = aff * COS(abog*add)
            z_oben = Ref1dzz(jkk+1)
            !
            afac = (zlvl(jk)-z_unten) / (z_oben-z_unten)
            u1d(jk) = u_unten + afac * (u_oben-u_unten)
            v1d(jk) = v_unten + afac * (v_oben-v_unten)
            !
            EXIT
         end if
      end do
      if ( MIN(u1d(jk),v1d(jk)) < -900. ) then
         write (99,*) 'Fehler bei Interpolation 1d-Referenzprofil auf Modellebene'
         write (99,*) 'Ebene k=',jk,' Hoehe ueber Grund: ',zlvl(jk),' m'
         STOP         'Fehler bei Interpolation 1d-Referenzprofil auf Modellebene'
      end if
   end do
   !
   do jk=lowb(3)+1,hghb(3)
      !
      if ( zlvl(jk) > 100. ) EXIT
      !
      aff1d = SQRT(u1d(jk)*u1d(jk)+v1d(jk)*v1d(jk))
      !
      Sum1d  (jk) = Sum1d  (jk) + u1d(jk)         + v1d(jk)
      Sum1d1d(jk) = Sum1d1d(jk) + u1d(jk)*u1d(jk) + v1d(jk)*v1d(jk)
      !
      do jj=lowb(2)+1,hghb(2)
      do ji=lowb(1)+1,hghb(1)
         !
         if ( .not. lstetig(ji,jj,jk) ) CYCLE
         !
         if ( dd(ji,jj,jk) < 0. ) then
            lstetig(ji,jj,jk) = .false.
            CYCLE
         endif
         !
         adelta = dd(ji,jj,jk) - ddm1(ji,jj,jk)
         if ( adelta < 0. ) adelta = adelta + 360.
         !
         adeltaHW = ddH - ddHm1
         if ( adeltaHW < 0. ) adeltaHW = adeltaHW + 360.
         !
         dddact(ji,jj,jk) = adelta - adeltaHW
         !
         if ( adelta > 180. ) then
            lstetig(ji,jj,jk) = .false.
            CYCLE
         !
         else
            dddelta(ji,jj,jk) = dddelta(ji,jj,jk) + ABS(dddact(ji,jj,jk))
         end if
         !
         au = 0.5 * ( u(ji-1,jj,jk) + u(ji,jj,jk) )
         av = 0.5 * ( v(ji,jj-1,jk) + v(ji,jj,jk) )
         aff3d = SQRT(au*au+av*av)
         Sum3d  (ji,jj,jk) = Sum3d  (ji,jj,jk) + au    + av
         Sum3d3d(ji,jj,jk) = Sum3d3d(ji,jj,jk) + au*au + av*av
         Sum1d3d(ji,jj,jk) = Sum1d3d(ji,jj,jk) + u1d(jk)*au + v1d(jk)*av
         !
         gfxyz_c(ji,jj,jk) = gfxyz_c(ji,jj,jk) + aff3d / (aff1d+1.e-9)
      end do
      end do
   end do
   !
   ddm1  = dd
   ddHm1 = ddH
   !
END Subroutine
