Subroutine sub_Read1d
   !---------------------------------------------------------------------------------------
   !     Einlesen der 1d-Referenzprofile
   !---------------------------------------------------------------------------------------
   !
   USE mo_global
   !
   IMPLICIT NONE
   !
   INTEGER  :: istat ,jl ,jak
   !
   OPEN(1,FILE='Ref1d.dat',IOSTAT=istat)
   if ( istat /= 0 ) then
      write (99,*) 'Fehler beim Oeffnen der Datei Ref1d.dat'
      STOP         'Fehler beim Oeffnen der Datei Ref1d.dat'
   end if
   !
   read (1,*,IOSTAT=istat) n1d
   if ( istat /= 0 ) then
      write (99,*) 'Fehler beim Lesen Anzahl Profilwerte aus Datei Ref1d.dat'
      STOP         'Fehler beim Lesen Anzahl Profilwerte aus Datei Ref1d.dat'
   end if
   if ( n1d > 1 ) then
      ALLOCATE ( Ref1dzz(1:n1d) ,Ref1dff(1:n1d,1:nAKS) ,Ref1ddd(1:n1d,1:nAKS) )
   else
      write (99,*) 'Fehler: Unzulaessiger Wert fuer Anzahl 1d-Profilwerte, n1d = ',n1d
      STOP         'Fehler: Unzulaessiger Wert fuer Anzahl 1d-Profilwerte'
   end if
   !
   read (1,*,IOSTAT=istat) cf1d(1:nAKS)
   if ( istat /= 0 ) then
      write (99,*) 'Fehler beim Lesen 1d-Profile aus Datei Ref1d.dat (Bibliothekskennungen)'
      STOP         'Fehler beim Lesen 1d-Profile aus Datei Ref1d.dat (Bibliothekskennungen)'
   end if
   do jl=1,n1d
      read (1,*,IOSTAT=istat) Ref1dzz(jl) ,(Ref1dff(jl,jak) ,Ref1ddd(jl,jak) ,jak=1,nAKS)
      if ( istat /= 0 ) then
         write (99,*) 'Fehler beim Lesen 1d-Profile aus Datei Ref1d.dat (Profilwerte z,ff,dd)'
         STOP         'Fehler beim Lesen 1d-Profile aus Datei Ref1d.dat (Profilwerte z,ff,dd)'
      end if
   end do
   !
   if ( Ref1dzz(1) < 0. .or. Ref1dzz(1) > 0. ) then
      write (99,*) 'Fehler: Erster 1d-Profilwert nicht am Boden'
      STOP         'Fehler: Erster 1d-Profilwert nicht am Boden'
   end if
   if ( Ref1dzz(n1d) < 100. ) then
      write (99,*) 'Fehler: Letzter 1d-Profilwert < 100 m ueber Grund'
      STOP         'Fehler: Letzter 1d-Profilwert < 100 m ueber Grund'
   end if
   do jl=2,n1d
      if ( Ref1dzz(jl) < Ref1dzz(jl-1) ) then
         write (99,*) 'Fehler: 1d-Profilwerte nicht in aufsteigender Hoehe'
         STOP         'Fehler: 1d-Profilwerte nicht in aufsteigender Hoehe'
      end if
   end do
   !
END Subroutine
